#ifndef __i386_UACCESS_H
#define __i386_UACCESS_H

/*
 * User space memory access functions
 */

#define VERIFY_READ 0
#define VERIFY_WRITE 1

#define access_ok(type,addr,size) 1

extern inline int verify_area(int type, const void * addr, unsigned long size)
{ return 0; }

#define get_user(x,ptr)	({ (x) = *ptr; })

#define put_user(x,ptr)	({ *ptr = (x); })

#define __copy_from_user(to,from,n)	\
     ({ int i;				\
     char *src = (char *)from, *dest = (char *)to;	\
     for ( i = 0; i < n; i++ )		\
         *dest++ = *src++;		\
     0;					\
     })

#define __copy_to_user(to,from,n) __copy_from_user(to,from,n)

#define copy_to_user(to,from,n)	__copy_to_user(to,from,n)

#define copy_from_user(to,from,n) __copy_from_user(to,from,n)

#endif /* __i386_UACCESS_H */


