
#define __KERNEL__ 1
#include <linux/types.h>
#include <linux/sched.h>

#include "control_w.h"
#include "fpu_emu.h"
#include "fpu_system.h"

#include "reportf.h"

#define NR_CPUS 1


#if 0
#define DEBUG
#define DEBUG2
#define DEBUG3
#endif

struct long_double {
  unsigned long long sig;
  unsigned short exp;
};

#define reg(x) ((struct long_double *)&((everything.Registers)[(x)*10]))[0]
#define reg0 ((struct long_double *)&(everything.Registers[0]))[0]
#define reg1 ((struct long_double *)&(everything.Registers[10]))[0]
#define reg2 ((struct long_double *)&(everything.Registers[20]))[0]
#define reg3 ((struct long_double *)&(everything.Registers[30]))[0]
#define reg4 ((struct long_double *)&(everything.Registers[40]))[0]
#define reg5 ((struct long_double *)&(everything.Registers[50]))[0]
#define reg6 ((struct long_double *)&(everything.Registers[60]))[0]
#define reg7 ((struct long_double *)&(everything.Registers[70]))[0]

struct fpu_state {
  unsigned control;
  unsigned status;
  unsigned tags;
  unsigned ip;
  unsigned cs;
  unsigned data;
  unsigned operand;
  char Registers[80];
};


extern struct fpu_state everything;
extern int top_;
extern char *argstr[8];
extern float floatarg;
extern double doublearg;
extern int integer32arg;
extern short integer16arg;

#define Empty        0
#define Valid        1
#define Valid1       2
#define Validh       3
#define Zero         4
#define Infinity     5
#define QNaN         6
#define SNaN         7
#define Denorm       8
#define PseudoDen    9
#define PseudoNaN   10
#define PseudoQNaN  11
#define PseudoSNaN  12
#define UnNormal    13
#define PseudoInf   14

#define REGISTER     0
#define INTEGER16    1
#define INTEGER32    2
#define FLOAT        3
#define DOUBLE       4
#define EXTENDED     5   /* The basic arithmetic functions do not operate
			    on extended memory operands */

int setup_reg(int regnr, int data_type, int reg_or_mem, int sign);
char *status_str(char *s, unsigned short sw);
void report_regs(struct info math_arg);
void report_all_regs(struct info math_arg);

